package com.wzhi.demo
import Money.tools._

object DataRepository {
  import TransType._
  def getUsdTransactions: List[Transaction[USD.type]] = {
    println("get transactions: Started")
    Thread.sleep(2000)
    println("get transactions: Done")
    List(
      Transaction(AccountID(1), InBound, BigDecimal(8) as USD),
      Transaction(AccountID(1), OutBound, BigDecimal(2) as USD),
      Transaction(AccountID(1), InBound, BigDecimal(5) as USD),
      Transaction(AccountID(1), OutBound, BigDecimal(2) as USD),
      Transaction(AccountID(1), OutBound, BigDecimal(3) as USD),
      Transaction(AccountID(2), InBound, BigDecimal(11) as USD),
      Transaction(AccountID(2), InBound, BigDecimal(1) as USD),
      Transaction(AccountID(2), OutBound, BigDecimal(5) as USD),
      Transaction(AccountID(2), InBound, BigDecimal(1) as USD),
      Transaction(AccountID(2), OutBound, BigDecimal(2) as USD),
      Transaction(AccountID(2), InBound, BigDecimal(1) as USD),
      Transaction(AccountID(3), InBound, BigDecimal(1) as USD)
    )
  }

  def getBalances: Map[AccountID, Money[USD.type]] = {
    println("get balances: Started")
    Thread.sleep(2000)
    println("get balances: Done")
    Map(
      AccountID(1) -> (2 as USD),
      AccountID(2) -> (7 as USD),
      AccountID(3) -> (1 as USD)
    )
  }

  val settlementExchangeRateMap: Map[Currency, Double] = Map(USD -> 1.0, CNY -> 0.14)
  def getSettlementExChangeRate(currency: Currency): Option[Double] = settlementExchangeRateMap.get(currency)
}
