package com.wzhi.demo

import zio._

object ZioDemo extends App {
  import zio.console._

//  def run(args: List[String]): ZIO[ZEnv, Nothing, ExitCode] = {
//    putStrLn("Hello World") as ExitCode(0)
//  }

  def run(args: List[String]): ZIO[ZEnv, Nothing, ExitCode] = {
    putStrLn("Hello") *> putStrLn("World") *> ZIO.succeed(ExitCode(0))
  }
}

object ErrRecovery extends App {
  import zio.console._
  val failed = putStrLn("About this file...") *> ZIO.fail("Uh, oh!")

  def run(args: List[String]): ZIO[ZEnv, Nothing, ExitCode] = {
    (failed as ExitCode(0)) catchAllCause (cause => putStrLn(cause.prettyPrint) as ExitCode(1))
  }

}
